searchData={"items":[{"type":"module","title":"Membrane.MP4.Container","doc":"Module for parsing and serializing MP4 files.\n\nBases on MP4 structure specification from `Membrane.MP4.Container.Schema`.","ref":"Membrane.MP4.Container.html"},{"type":"function","title":"Membrane.MP4.Container.box_path/1","doc":"Maps a path in the MP4 box tree into sequence of keys under which that\nbox resides in MP4.","ref":"Membrane.MP4.Container.html#box_path/1"},{"type":"function","title":"Membrane.MP4.Container.get_box/2","doc":"Gets a box from a given path in a parsed MP4.","ref":"Membrane.MP4.Container.html#get_box/2"},{"type":"function","title":"Membrane.MP4.Container.parse/1","doc":"Parses binary data to MP4 according to `Membrane.MP4.Container.Schema.schema/0`.\n\nReturns boxes that have been correctly parsed, and the leftover data that\nis insufficient to constitute a complete box.","ref":"Membrane.MP4.Container.html#parse/1"},{"type":"function","title":"Membrane.MP4.Container.parse/2","doc":"Parses binary data to MP4 according to a custom schema.\n\nReturns boxes that have been correctly parsed, and the leftover data that\nis insufficient to constitute a complete box.","ref":"Membrane.MP4.Container.html#parse/2"},{"type":"function","title":"Membrane.MP4.Container.parse!/1","doc":"Same as `parse/1`, raises on error.","ref":"Membrane.MP4.Container.html#parse!/1"},{"type":"function","title":"Membrane.MP4.Container.parse!/2","doc":"Same as `parse/2`, raises on error.","ref":"Membrane.MP4.Container.html#parse!/2"},{"type":"function","title":"Membrane.MP4.Container.serialize/1","doc":"Serializes MP4 to a binary according to `Membrane.MP4.Container.Schema.schema/0`.","ref":"Membrane.MP4.Container.html#serialize/1"},{"type":"function","title":"Membrane.MP4.Container.serialize/2","doc":"Serializes MP4 to a binary according to a custom schema.","ref":"Membrane.MP4.Container.html#serialize/2"},{"type":"function","title":"Membrane.MP4.Container.serialize!/1","doc":"Same as `serialize/1`, raises on error","ref":"Membrane.MP4.Container.html#serialize!/1"},{"type":"function","title":"Membrane.MP4.Container.serialize!/2","doc":"Same as `serialize/2`, raises on error","ref":"Membrane.MP4.Container.html#serialize!/2"},{"type":"function","title":"Membrane.MP4.Container.update_box/4","doc":"Updates a box at a given path in a parsed MP4.\n\nIf `parameter_path` is set, a parameter within a box is updated.","ref":"Membrane.MP4.Container.html#update_box/4"},{"type":"type","title":"Membrane.MP4.Container.box_name_t/0","doc":"","ref":"Membrane.MP4.Container.html#t:box_name_t/0"},{"type":"type","title":"Membrane.MP4.Container.field_name_t/0","doc":"","ref":"Membrane.MP4.Container.html#t:field_name_t/0"},{"type":"type","title":"Membrane.MP4.Container.fields_t/0","doc":"","ref":"Membrane.MP4.Container.html#t:fields_t/0"},{"type":"type","title":"Membrane.MP4.Container.parse_error_context_t/0","doc":"","ref":"Membrane.MP4.Container.html#t:parse_error_context_t/0"},{"type":"type","title":"Membrane.MP4.Container.serialize_error_context_t/0","doc":"","ref":"Membrane.MP4.Container.html#t:serialize_error_context_t/0"},{"type":"type","title":"Membrane.MP4.Container.t/0","doc":"","ref":"Membrane.MP4.Container.html#t:t/0"},{"type":"module","title":"Membrane.MP4.Container.Header","doc":"A structure describing the header of the box.\n\nThe `content_size` field is equal to the box size minus the size of the header (8 bytes).","ref":"Membrane.MP4.Container.Header.html"},{"type":"function","title":"Membrane.MP4.Container.Header.parse/1","doc":"Parses the header of a box.\n\nReturns the `t:t/0` and the leftover data.","ref":"Membrane.MP4.Container.Header.html#parse/1"},{"type":"type","title":"Membrane.MP4.Container.Header.t/0","doc":"","ref":"Membrane.MP4.Container.Header.html#t:t/0"},{"type":"module","title":"Membrane.MP4.Container.Schema","doc":"MP4 structure schema used for parsing and serialization.\n\nUseful resources:\n- https://www.iso.org/standard/79110.html\n- https://www.iso.org/standard/61988.html\n- https://developer.apple.com/library/archive/documentation/QuickTime/QTFF/QTFFChap2/qtff2.html\n- https://github.com/DicomJ/mpeg-isobase/tree/eb09f82ff6e160715dcb34b2bf473330c7695d3b","ref":"Membrane.MP4.Container.Schema.html"},{"type":"function","title":"Membrane.MP4.Container.Schema.schema/0","doc":"Returns `t:Membrane.MP4.Container.Schema.t/0`","ref":"Membrane.MP4.Container.Schema.html#schema/0"},{"type":"type","title":"Membrane.MP4.Container.Schema.field_t/0","doc":"A box field type.\n\nIt may contain a primitive, a list or nested fields. Lists last till the end of a box.","ref":"Membrane.MP4.Container.Schema.html#t:field_t/0"},{"type":"type","title":"Membrane.MP4.Container.Schema.primitive_t/0","doc":"For fields, the following primitive types are supported:\n- `{:int, bit_size}` - a signed integer\n- `{:uint, bit_size}` - an unsigned integer\n- `:bin` - a binary lasting till the end of a box\n- `{:bin, bit_size}` - a binary of given size\n- `:str` - a string terminated with a null byte\n- `{:str, bit_size}` - a string of given size\n- `{:fp, integer_part_bit_size, fractional_part_bit_size}` - a fixed point number","ref":"Membrane.MP4.Container.Schema.html#t:primitive_t/0"},{"type":"type","title":"Membrane.MP4.Container.Schema.schema_def_box_t/0","doc":"","ref":"Membrane.MP4.Container.Schema.html#t:schema_def_box_t/0"},{"type":"type","title":"Membrane.MP4.Container.Schema.schema_def_field_t/0","doc":"","ref":"Membrane.MP4.Container.Schema.html#t:schema_def_field_t/0"},{"type":"type","title":"Membrane.MP4.Container.Schema.schema_def_primitive_t/0","doc":"","ref":"Membrane.MP4.Container.Schema.html#t:schema_def_primitive_t/0"},{"type":"type","title":"Membrane.MP4.Container.Schema.schema_def_t/0","doc":"Type describing the schema definition, that is hardcoded in this module.\n\nIt may be useful for improving the schema definition. The actual schema that\nshould be operated on, or, in other words, the parsed schema definition is\nspecified by `t:Membrane.MP4.Container.Schema.t/0`.\n\nThe schema definition differs from the final schema in the following ways:\n  - primitives along with their parameters are specified as atoms, for example\n  `:int32` instead of `{:int, 32}`\n  - child boxes are nested within their parents directly, instead of residing\n  under `:children` key.\n\nThe schema definition is the following:\n```\n[\n  ftyp: [\n    fields: [\n      major_brand: :str32,\n      major_brand_version: :uint32,\n      compatible_brands: {:list, :str32}\n    ]\n  ],\n  moov: [\n    mvhd: [\n      version: 0,\n      fields: [\n        version: {:uint8, [store: :version]},\n        flags: {:uint24, [store: :fo_flags]},\n        creation_time: {:uint32, [when: {:version, [value: 0]}]},\n        creation_time: {:uint64, [when: {:version, [value: 1]}]},\n        modification_time: {:uint32, [when: {:version, [value: 0]}]},\n        modification_time: {:uint64, [when: {:version, [value: 1]}]},\n        timescale: :uint32,\n        duration: {:uint32, [when: {:version, [value: 0]}]},\n        duration: {:uint64, [when: {:version, [value: 1]}]},\n        rate: :fp16d16,\n        volume: :fp8d8,\n        reserved: <<0, 0, 0, 0, 0, 0, 0, 0, 0, 0>>,\n        matrix_value_A: :fp16d16,\n        matrix_value_B: :fp16d16,\n        matrix_value_U: :fp2d30,\n        matrix_value_C: :fp16d16,\n        matrix_value_D: :fp16d16,\n        matrix_value_V: :fp2d30,\n        matrix_value_X: :fp16d16,\n        matrix_value_Y: :fp16d16,\n        matrix_value_W: :fp2d30,\n        quicktime_preview_time: :uint32,\n        quicktime_preview_duration: :uint32,\n        quicktime_poster_time: :uint32,\n        quicktime_selection_time: :uint32,\n        quicktime_selection_duration: :uint32,\n        quicktime_current_time: :uint32,\n        next_track_id: :uint32\n      ]\n    ],\n    trak: [\n      tkhd: [\n        version: 0,\n        fields: [\n          version: {:uint8, [store: :version]},\n          flags: {:uint24, [store: :fo_flags]},\n          creation_time: {:uint32, [when: {:version, [value: 0]}]},\n          creation_time: {:uint64, [when: {:version, [value: 1]}]},\n          modification_time: {:uint32, [when: {:version, [value: 0]}]},\n          modification_time: {:uint64, [when: {:version, [value: 1]}]},\n          track_id: :uint32,\n          reserved: <<0, 0, 0, 0>>,\n          duration: {:uint32, [when: {:version, [value: 0]}]},\n          duration: {:uint64, [when: {:version, [value: 1]}]},\n          reserved: <<0, 0, 0, 0, 0, 0, 0, 0>>,\n          layer: :int16,\n          alternate_group: :int16,\n          volume: :fp8d8,\n          reserved: <<0, 0>>,\n          matrix_value_A: :fp16d16,\n          matrix_value_B: :fp16d16,\n          matrix_value_U: :fp2d30,\n          matrix_value_C: :fp16d16,\n          matrix_value_D: :fp16d16,\n          matrix_value_V: :fp2d30,\n          matrix_value_X: :fp16d16,\n          matrix_value_Y: :fp16d16,\n          matrix_value_W: :fp2d30,\n          width: :fp16d16,\n          height: :fp16d16\n        ]\n      ],\n      mdia: [\n        mdhd: [\n          version: 0,\n          fields: [\n            version: {:uint8, [store: :version]},\n            flags: {:uint24, [store: :fo_flags]},\n            creation_time: {:uint32, [when: {:version, [value: 0]}]},\n            creation_time: {:uint64, [when: {:version, [value: 1]}]},\n            modification_time: {:uint32, [when: {:version, [value: 0]}]},\n            modification_time: {:uint64, [when: {:version, [value: 1]}]},\n            timescale: :uint32,\n            duration: {:uint32, [when: {:version, [value: 0]}]},\n            duration: {:uint64, [when: {:version, [value: 1]}]},\n            reserved: <<0::size(1)>>,\n            language: :uint15,\n            reserved: <<0, 0>>\n          ]\n        ],\n        hdlr: [\n          version: 0,\n          fields: [\n            version: {:uint8, [store: :version]},\n            flags: {:uint24, [store: :fo_flags]},\n            reserved: <<0, 0, 0, 0>>,\n            handler_type: :str32,\n            reserved: <<0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0>>,\n            name: :str\n          ]\n        ],\n        minf: [\n          vmhd: [\n            version: 0,\n            fields: [\n              version: {:uint8, [store: :version]},\n              flags: {:uint24, [store: :fo_flags]},\n              graphics_mode: :uint16,\n              opcolor: :uint48\n            ]\n          ],\n          smhd: [\n            version: 0,\n            fields: [\n              version: {:uint8, [store: :version]},\n              flags: {:uint24, [store: :fo_flags]},\n              balance: :fp8d8,\n              reserved: <<0, 0>>\n            ]\n          ],\n          dinf: [\n            dref: [\n              version: 0,\n              fields: [\n                version: {:uint8, [store: :version]},\n                flags: {:uint24, [store: :fo_flags]},\n                entry_count: :uint32\n              ],\n              url: [\n                version: 0,\n                fields: [\n                  version: {:uint8, [store: :version]},\n                  flags: {:uint24, [store: :fo_flags]}\n                ]\n              ]\n            ]\n          ],\n          stbl: [\n            stsd: [\n              version: 0,\n              fields: [\n                version: {:uint8, [store: :version]},\n                flags: {:uint24, [store: :fo_flags]},\n                entry_count: :uint32\n              ],\n              avc1: [\n                version: 0,\n                fields: [\n                  version: {:uint8, [store: :version]},\n                  flags: {:uint24, [store: :fo_flags]},\n                  num_of_entries: :uint32,\n                  reserved: <<0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0>>,\n                  width: :uint16,\n                  height: :uint16,\n                  horizresolution: :fp16d16,\n                  vertresolution: :fp16d16,\n                  reserved: <<0, 0, 0, 0>>,\n                  frame_count: :uint16,\n                  compressor_name: :str256,\n                  depth: :uint16,\n                  reserved: <<255, 255>>\n                ],\n                avcC: [black_box?: true],\n                pasp: [fields: [h_spacing: :uint32, v_spacing: :uint32]]\n              ],\n              avc3: [\n                version: 0,\n                fields: [\n                  version: {:uint8, [store: :version]},\n                  flags: {:uint24, [store: :fo_flags]},\n                  num_of_entries: :uint32,\n                  reserved: <<0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0>>,\n                  width: :uint16,\n                  height: :uint16,\n                  horizresolution: :fp16d16,\n                  vertresolution: :fp16d16,\n                  reserved: <<0, 0, 0, 0>>,\n                  frame_count: :uint16,\n                  compressor_name: :str256,\n                  depth: :uint16,\n                  reserved: <<255, 255>>\n                ],\n                avcC: [black_box?: true],\n                pasp: [fields: [h_spacing: :uint32, v_spacing: :uint32]]\n              ],\n              hvc1: [\n                version: 0,\n                fields: [\n                  version: {:uint8, [store: :version]},\n                  flags: {:uint24, [store: :fo_flags]},\n                  num_of_entries: :uint32,\n                  reserved: <<0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0>>,\n                  width: :uint16,\n                  height: :uint16,\n                  horizresolution: :fp16d16,\n                  vertresolution: :fp16d16,\n                  reserved: <<0, 0, 0, 0>>,\n                  frame_count: :uint16,\n                  compressor_name: :str256,\n                  depth: :uint16,\n                  reserved: <<255, 255>>\n                ],\n                hvcC: [black_box?: true],\n                pasp: [fields: [h_spacing: :uint32, v_spacing: :uint32]]\n              ],\n              hev1: [\n                version: 0,\n                fields: [\n                  version: {:uint8, [store: :version]},\n                  flags: {:uint24, [store: :fo_flags]},\n                  num_of_entries: :uint32,\n                  reserved: <<0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0>>,\n                  width: :uint16,\n                  height: :uint16,\n                  horizresolution: :fp16d16,\n                  vertresolution: :fp16d16,\n                  reserved: <<0, 0, 0, 0>>,\n                  frame_count: :uint16,\n                  compressor_name: :str256,\n                  depth: :uint16,\n                  reserved: <<255, 255>>\n                ],\n                hvcC: [black_box?: true],\n                pasp: [fields: [h_spacing: :uint32, v_spacing: :uint32]]\n              ],\n              mp4a: [\n                fields: [\n                  reserved: <<0, 0, 0, 0, 0, 0>>,\n                  data_reference_index: :uint16,\n                  encoding_version: :uint16,\n                  encoding_revision: :uint16,\n                  encoding_vendor: :uint32,\n                  channel_count: :uint16,\n                  sample_size: :uint16,\n                  compression_id: :uint16,\n                  packet_size: :uint16,\n                  sample_rate: :fp16d16\n                ],\n                esds: [\n                  version: 0,\n                  fields: [\n                    version: {:uint8, [store: :version]},\n                    flags: {:uint24, [store: :fo_flags]},\n                    elementary_stream_descriptor: :bin\n                  ]\n                ]\n              ],\n              Opus: [\n                version: 0,\n                fields: [\n                  reserved: <<0, 0, 0, 0, 0, 0>>,\n                  data_reference_index: :uint16,\n                  reserved: <<0, 0, 0, 0, 0, 0, 0, 0>>,\n                  channel_count: :uint16,\n                  sample_size: :uint16,\n                  reserved: <<0, 0>>,\n                  reserved: <<0, 0>>,\n                  sample_rate: :uint32\n                ],\n                dOps: [\n                  version: 0,\n                  fields: [\n                    version: :uint8,\n                    output_channel_count: :uint8,\n                    pre_skip: :uint16,\n                    input_sample_rate: :uint32,\n                    output_gain: :int16,\n                    channel_mapping_family: :uint8\n                  ]\n                ]\n              ]\n            ],\n            stts: [\n              version: 0,\n              fields: [\n                version: {:uint8, [store: :version]},\n                flags: {:uint24, [store: :fo_flags]},\n                entry_count: :uint32,\n                entry_list: {:list,\n                 [sample_count: :uint32, sample_delta: :uint32]}\n              ]\n            ],\n            stss: [\n              version: 0,\n              fields: [\n                version: {:uint8, [store: :version]},\n                flags: {:uint24, [store: :fo_flags]},\n                entry_count: :uint32,\n                entry_list: {:list, [sample_number: :uint32]}\n              ]\n            ],\n            ctts: [\n              version: 0,\n              fields: [\n                version: {:uint8, [store: :version]},\n                flags: {:uint24, [store: :fo_flags]},\n                entry_count: :uint32,\n                entry_list: {:list,\n                 [sample_count: :uint32, sample_composition_offset: :uint32]}\n              ]\n            ],\n            stsc: [\n              version: 0,\n              fields: [\n                version: {:uint8, [store: :version]},\n                flags: {:uint24, [store: :fo_flags]},\n                entry_count: :uint32,\n                entry_list: {:list,\n                 [\n                   first_chunk: :uint32,\n                   samples_per_chunk: :uint32,\n                   sample_description_index: :uint32\n                 ]}\n              ]\n            ],\n            stsz: [\n              version: 0,\n              fields: [\n                version: {:uint8, [store: :version]},\n                flags: {:uint24, [store: :fo_flags]},\n                sample_size: :uint32,\n                sample_count: :uint32,\n                entry_list: {:list, [entry_size: :uint32]}\n              ]\n            ],\n            stco: [\n              version: 0,\n              fields: [\n                version: {:uint8, [store: :version]},\n                flags: {:uint24, [store: :fo_flags]},\n                entry_count: :uint32,\n                entry_list: {:list, [chunk_offset: :uint32]}\n              ]\n            ],\n            co64: [\n              version: 0,\n              fields: [\n                version: {:uint8, [store: :version]},\n                flags: {:uint24, [store: :fo_flags]},\n                entry_count: :uint32,\n                entry_list: {:list, [chunk_offset: :uint64]}\n              ]\n            ]\n          ]\n        ]\n      ]\n    ],\n    mvex: [\n      trex: [\n        version: 0,\n        fields: [\n          version: {:uint8, [store: :version]},\n          flags: {:uint24, [store: :fo_flags]},\n          track_id: :uint32,\n          default_sample_description_index: :uint32,\n          default_sample_duration: :uint32,\n          default_sample_size: :uint32,\n          default_sample_flags: :uint32\n        ]\n      ]\n    ]\n  ],\n  styp: [\n    fields: [\n      major_brand: :str32,\n      major_brand_version: :uint32,\n      compatible_brands: {:list, :str32}\n    ]\n  ],\n  sidx: [\n    version: 1,\n    fields: [\n      version: {:uint8, [store: :version]},\n      flags: {:uint24, [store: :fo_flags]},\n      reference_id: :uint32,\n      timescale: :uint32,\n      earliest_presentation_time: :uint64,\n      first_offset: :uint64,\n      reserved: <<0, 0>>,\n      reference_count: :uint16,\n      reference_type: :bin1,\n      referenced_size: :uint31,\n      subsegment_duration: :uint32,\n      starts_with_sap: :bin1,\n      sap_type: :uint3,\n      sap_delta_time: :uint28\n    ]\n  ],\n  moof: [\n    mfhd: [\n      version: 0,\n      fields: [\n        version: {:uint8, [store: :version]},\n        flags: {:uint24, [store: :fo_flags]},\n        sequence_number: :uint32\n      ]\n    ],\n    traf: [\n      tfhd: [\n        version: 0,\n        fields: [\n          version: {:uint8, [store: :version]},\n          flags: {:uint24, [store: :fo_flags]},\n          track_id: :uint32,\n          default_sample_duration: :uint32,\n          default_sample_size: :uint32,\n          default_sample_flags: :uint32\n        ]\n      ],\n      tfdt: [\n        version: 1,\n        fields: [\n          version: {:uint8, [store: :version]},\n          flags: {:uint24, [store: :fo_flags]},\n          base_media_decode_time: :uint64\n        ]\n      ],\n      trun: [\n        version: 0,\n        fields: [\n          version: {:uint8, [store: :version]},\n          flags: {:uint24, [store: :fo_flags]},\n          sample_count: :uint32,\n          data_offset: :int32,\n          samples: {:list,\n           [\n             sample_duration: :uint32,\n             sample_size: :uint32,\n             sample_flags: :bin32,\n             sample_composition_offset: {:uint32,\n              [when: {:fo_flags, [mask: 2048]}]}\n           ]}\n        ]\n      ]\n    ]\n  ],\n  mdat: [black_box?: true]\n]\n```","ref":"Membrane.MP4.Container.Schema.html#t:schema_def_t/0"},{"type":"type","title":"Membrane.MP4.Container.Schema.t/0","doc":"The schema of MP4 structure.\n\nAn MP4 file consists of boxes, that all have the same header and different internal\nstructures. Boxes can be nested with one another.\n\nEach box has at most 4-letter name and may have the following parameters:\n- `black_box?` - if true, the box content is unspecified and is treated as an opaque\nbinary. Defaults to false.\n- `version` - the box version. Versions usually differ by the sizes of particular fields.\n- `fields` - a list of key-value parameters\n- `children` - the nested boxes","ref":"Membrane.MP4.Container.Schema.html#t:t/0"},{"type":"module","title":"Membrane.MP4.Track","doc":"A module defining a structure that represents an MPEG-4 track.\n\nAll new samples of a track must be stored in the structure first in order\nto build a sample table of a regular MP4 container. Samples that were stored\ncan be flushed later in form of chunks.","ref":"Membrane.MP4.Track.html"},{"type":"function","title":"Membrane.MP4.Track.completed?/1","doc":"","ref":"Membrane.MP4.Track.html#completed?/1"},{"type":"function","title":"Membrane.MP4.Track.finalize/2","doc":"","ref":"Membrane.MP4.Track.html#finalize/2"},{"type":"function","title":"Membrane.MP4.Track.flush_chunk/2","doc":"","ref":"Membrane.MP4.Track.html#flush_chunk/2"},{"type":"function","title":"Membrane.MP4.Track.get_encoding_info/1","doc":"","ref":"Membrane.MP4.Track.html#get_encoding_info/1"},{"type":"function","title":"Membrane.MP4.Track.new/3","doc":"","ref":"Membrane.MP4.Track.html#new/3"},{"type":"function","title":"Membrane.MP4.Track.store_sample/2","doc":"","ref":"Membrane.MP4.Track.html#store_sample/2"},{"type":"type","title":"Membrane.MP4.Track.t/0","doc":"","ref":"Membrane.MP4.Track.html#t:t/0"},{"type":"module","title":"Membrane.MP4.Track.SampleTable","doc":"A module that defines a structure and functions allowing to store samples,\nassemble them into chunks and flush when needed. Its public functions take\ncare of recording information required to build a sample table.\n\nFor performance reasons, the module uses prepends when storing information\nabout new samples. To compensate for it, use `&Membrane.MP4.Track.SampleTable.reverse/1`\nwhen it's known that no more samples will be stored.","ref":"Membrane.MP4.Track.SampleTable.html"},{"type":"function","title":"Membrane.MP4.Track.SampleTable.chunk_duration/1","doc":"","ref":"Membrane.MP4.Track.SampleTable.html#chunk_duration/1"},{"type":"function","title":"Membrane.MP4.Track.SampleTable.flush_chunk/2","doc":"","ref":"Membrane.MP4.Track.SampleTable.html#flush_chunk/2"},{"type":"function","title":"Membrane.MP4.Track.SampleTable.reverse/1","doc":"","ref":"Membrane.MP4.Track.SampleTable.html#reverse/1"},{"type":"function","title":"Membrane.MP4.Track.SampleTable.store_sample/2","doc":"","ref":"Membrane.MP4.Track.SampleTable.html#store_sample/2"},{"type":"type","title":"Membrane.MP4.Track.SampleTable.t/0","doc":"","ref":"Membrane.MP4.Track.SampleTable.html#t:t/0"},{"type":"module","title":"Membrane.MP4.Muxer.CMAF","doc":"Puts a payloaded stream into [Common Media Application Format](https://www.wowza.com/blog/what-is-cmaf),\nan MP4-based container commonly used in adaptive streaming over HTTP.","ref":"Membrane.MP4.Muxer.CMAF.html"},{"type":"module","title":"Input/Output tracks matrix - Membrane.MP4.Muxer.CMAF","doc":"The basic muxer's functionality is to take a single media stream and put it into CMAF formatted track.\n\nSometimes one may need to mux several tracks together or make sure that output tracks are\nsynchronized with each other. Such behavior is also supported by the muxer's implementation.\n\nEach output pad can specify which input pads needs to be muxed together by specifying `:tracks` option.\n\nOne may also want to have separate output pads that are internally synchronized with each other (then\nthe `:tracks` should contain only a single id). By synchronization we mean that the muxer will try its best\nto produce equal length segments for output pads. The synchronization relies on the video track (the video\ntrack can only be cut at keyframe boundries, audio track can be cut at any point).\n\nThis approach enforces that there is no more than a single video track. A video track is always used as a synchronization point\ntherefore having more than one would make the synchronization decisions ambiguous. The amount of audio tracks on the other\nhand is not limited.\n\nAs a rule of thumb, if there is no need to synchronize tracks just use separate muxer instances.\n\nThe example matrix of possible input/ouput tracks is as follows:\n- audio input -> audio output\n- video input -> video output\n- audio input + video input  -> muxed audio/video output\n- audio-1 input + ... + audio-n input + video input  -> audio-1 output + ... + audio-n output  + video output","ref":"Membrane.MP4.Muxer.CMAF.html#module-input-output-tracks-matrix"},{"type":"module","title":"Media objects - Membrane.MP4.Muxer.CMAF","doc":"Accordingly to the spec, the `Membrane.MP4.Muxer.CMAF` is able to assemble the following media entities:\n  * `header` - media initialization object. Contains information necessary to play the media segments.\n  The media header content is sent inside of a stream format on the target output pad.\n\n* `segment` - a sequence of one or more consecutive fragments belonging to a particular track that are playable on their own\n  when combined with a media header.\n  Segments due to their nature (video decoding) must start with a key frame (doesn't apply to audio-only tracks) which\n  is a main driver when collecting video samples and deciding when a segment should be created\n\n* `chunk` - a fragment consisting of a subset of media samples, not necessairly playable on its own. Chunk\n  no longer has the requirement to start with a key frame (except for the first chunk that starts a new segment)\n  and its main goal is to reduce the latency of creating the media segments (chunks can be delivered to a client faster so it can\n  start playing them before a full segment gets assembled)\n\n#","ref":"Membrane.MP4.Muxer.CMAF.html#module-media-objects"},{"type":"module","title":"Segment/Chunk metadata - Membrane.MP4.Muxer.CMAF","doc":"Each outgoing buffer containing a segment/chunk contains the following fields in the buffer's metadata:\n* `duration` - the duration of the underlying segment/chunk\n\n* `independent?` - tells if a segment/chunk can be independently played (starts with a keyframe), it is always true for segments\n\n* `last_chunk?` - tells if the underlying chunk is the last one of the segment currently being assembled, for segments this flag is always true\n  and has no real meaning","ref":"Membrane.MP4.Muxer.CMAF.html#module-segment-chunk-metadata"},{"type":"module","title":"Segment creation - Membrane.MP4.Muxer.CMAF","doc":"A segment gets created based on the duration of currently collected media samples and\n  `:segment_min_duration` options passed when initializing `Membrane.MP4.Muxer.CMAF`.\n\nIt is expected that the segment will not be shorter than the specified minimum duration value\nand the aim is to end the segment as soon as the next key frames arrives (for audio-only tracks the segment can be ended after each sample)\nthat will become a part of a new segment.\n\nIf a user prefers to have segments of unified durations then he needs to take into consideration\nthe incoming keyframes interval. For instance, if a keyframe interval is 2 seconds and the goal is to have\n6 seconds segments then the minimum segment duration should be lower than 6 seconds (the key frame at the\n6-second mark will force the segment finalization).\n\n> #","ref":"Membrane.MP4.Muxer.CMAF.html#module-segment-creation"},{"type":"module","title":"Note - Membrane.MP4.Muxer.CMAF","doc":"> If a key frame comes at irregular intervals, the segment could be much longer than expected as after the minimum\n> duration muxer will always look for a key frame to finish the segment.","ref":"Membrane.MP4.Muxer.CMAF.html#module-note"},{"type":"module","title":"Forcing segment creation - Membrane.MP4.Muxer.CMAF","doc":"It may happen that one may need to create a segment before it reaches the minimum duration (for purposes such as fast AD insertion).\n\nTo instruct the muxer to finalize the current segment as soon as possible one can send `Membrane.MP4.Muxer.CMAF.RequestMediaFinalization`\nevent on any `:output` pad. The event will enforce the muxer to end the current segment as soon as possible (usually on the nearest key frame).\nAfter the segment gets generated, the muxer will go back to its normal behaviour of creating segments.","ref":"Membrane.MP4.Muxer.CMAF.html#module-forcing-segment-creation"},{"type":"module","title":"Chunk creation - Membrane.MP4.Muxer.CMAF","doc":"As previously mentioned, chunks are not required to start with a key frame except for\na first chunk of a new segment. Those are once again created based on the duration of the collected\nsamples but this time the process needs to be smarter as we can't allow the chunk to significantly exceed\ntheir target duration.\n\nExceeding the chunk's target duration can cause unrecoverable player stalls e.g. when\nplaying LL-HLS on Safari, same goes if the chunk's duration is lower than 85% of the target duration\nwhen the chunk is the not last of its parent segment (Safari again). This is why\nproper duration MUST get collected. The limitation does not apply to the last chunk of a given regular segment.\n\nThe behaviour of creating chunk is as follows:\n* if the duration of the **regular** segment currently being assembled is lower than the minimum then\n  try to collect chunk with its given `target` duration value no matter what\n\n* if the duration of the **regular** segment currently being assembled is greater than the minimum then try to\n  finish the chunk as fast as possible (without exceeding the chunk's target) when encountering a key frame. When such chunk\n  gets created it also means that its parent segment is also done.\n\nNote that once the `Membrane.MP4.Muxer.CMAF` is in a phase of finalizing a **regular** segment, more than one\nchunk could get created until a key frame is encountered.\n\n> #","ref":"Membrane.MP4.Muxer.CMAF.html#module-chunk-creation"},{"type":"module","title":"Important for video {: .warning} - Membrane.MP4.Muxer.CMAF","doc":">\n> `:chunk_target_duration` should be chosen with special care and appropriately for its use case.\n> It is unnecessary to create chunks when the target use case is not live streaming.\n>\n> The chunk duration usability may depend on its use case e.g. for live streaming there is very little value for having duration higher\n> than 1s/2s, also having really short duration may add a communication overhead for a client (a necessity for downloading many small chunks).\n\n>","ref":"Membrane.MP4.Muxer.CMAF.html#module-important-for-video-warning"},{"type":"module","title":"Note - Membrane.MP4.Muxer.CMAF","doc":"> If a stream contains non-key frames (like H264 P or B frames), they should be marked\n> with a `h264: %{key_frame?: false}` metadata entry.","ref":"Membrane.MP4.Muxer.CMAF.html#module-note"},{"type":"module","title":"Element options - Membrane.MP4.Muxer.CMAF","doc":"Passed via struct `t:Membrane.MP4.Muxer.CMAF.t/0`\n\n- `segment_min_duration`  \n\n  ```\n  Membrane.Time.t()\n  ```\n  \n  Default value: `2000000000`  \n  Minimum duration of a regular media segment.\n  \n  When the minimum duration is reached the muxer will try to finalize the segment as soon as\n  a new key frame arrives which will start a new segment.\n\n\n- `chunk_target_duration`  \n\n  ```\n  Membrane.Time.t() | nil\n  ```\n  \n  Default value: `nil`","ref":"Membrane.MP4.Muxer.CMAF.html#module-element-options"},{"type":"module","title":"Pads - Membrane.MP4.Muxer.CMAF","doc":"### `:input`\n\nAccepted formats:\n```\n%AAC{config: {:esds, _esds}}\n```\n```\n%Opus{self_delimiting?: false}\n```\n```\n%H264{stream_structure: structure, alignment: :au} when H264.is_avc(structure)\n```\n```\n%H265{stream_structure: structure, alignment: :au} when H265.is_hvc(structure)\n```\n\nDirection: | `:input`\nAvailability: | `:on_request`\nFlow control: | `:manual`\nDemand unit: | `:buffers`\n\n\n### `:output`\n\nAccepted formats:\n```\nMembrane.CMAF.Track\n```\n\nDirection: | `:output`\nAvailability: | `:on_request`\nFlow control: | `:manual`\nDemand unit: | `nil`\nPad options:\n\n- `tracks`  \n\n  ```\n  [Membrane.Pad.dynamic_id()] | :all\n  ```\n  \n  Default value: `:all`  \n  A list of the input pad ids that should be muxed together into a single output track.\n  \n  If not specified the pad will include all unreferenced input pads.","ref":"Membrane.MP4.Muxer.CMAF.html#module-pads"},{"type":"function","title":"Membrane.MP4.Muxer.CMAF.options/0","doc":"Returns description of options available for this module","ref":"Membrane.MP4.Muxer.CMAF.html#options/0"},{"type":"type","title":"Membrane.MP4.Muxer.CMAF.output_pad_opts/0","doc":"Options for pad `:output`","ref":"Membrane.MP4.Muxer.CMAF.html#t:output_pad_opts/0"},{"type":"type","title":"Membrane.MP4.Muxer.CMAF.t/0","doc":"Struct containing options for `Membrane.MP4.Muxer.CMAF`","ref":"Membrane.MP4.Muxer.CMAF.html#t:t/0"},{"type":"module","title":"Membrane.MP4.Muxer.CMAF.RequestMediaFinalization","doc":"Membrane's event representing a request for a `Membrane.MP4.Muxer.CMAF` element\nto finalize the current segment as soon as possible.","ref":"Membrane.MP4.Muxer.CMAF.RequestMediaFinalization.html"},{"type":"type","title":"Membrane.MP4.Muxer.CMAF.RequestMediaFinalization.t/0","doc":"","ref":"Membrane.MP4.Muxer.CMAF.RequestMediaFinalization.html#t:t/0"},{"type":"module","title":"Membrane.MP4.Muxer.ISOM","doc":"Puts payloaded streams into an MPEG-4 container.","ref":"Membrane.MP4.Muxer.ISOM.html"},{"type":"module","title":"Element options - Membrane.MP4.Muxer.ISOM","doc":"Passed via struct `t:Membrane.MP4.Muxer.ISOM.t/0`\n\n- `fast_start`  \n\n  ```\n  boolean()\n  ```\n  \n  Default value: `false`  \n  Generates a container more suitable for streaming by allowing media players to start\n  playback as soon as they start to receive its media data.\n  \n  When set to `true`, the container metadata (`moov` atom) will be placed before media\n  data (`mdat` atom). The equivalent of FFmpeg's `-movflags faststart` option.\n  [IMPORTANT] Due to the structure of MPEG-4 containers, the muxer with `fast_start: true`\n  has to be used along with `Membrane.File.Sink` or any other sink that can handle `Membrane.File.SeekSinkEvent`,\n  since that event is used to insert `moov` box at the beginning of the file.\n\n\n- `chunk_duration`  \n\n  ```\n  Time.t()\n  ```\n  \n  Default value: `1000000000`  \n  Expected duration of each chunk in the resulting MP4 container.\n  \n  Once the total duration of samples received on one of the input pads exceeds\n  that threshold, a chunk containing these samples is flushed. Interleaving chunks\n  belonging to different tracks may have positive impact on performance of media players.","ref":"Membrane.MP4.Muxer.ISOM.html#module-element-options"},{"type":"module","title":"Pads - Membrane.MP4.Muxer.ISOM","doc":"### `:input`\n\nAccepted formats:\n```\n%Membrane.AAC{config: {:esds, _esds}}\n```\n```\n%Membrane.H264{stream_structure: {:avc1, _dcr}, alignment: :au}\n```\n```\n%Membrane.H265{stream_structure: {_hevc, _dcr}, alignment: :au}\n```\n```\n%Membrane.Opus{self_delimiting?: false}\n```\n\nDirection: | `:input`\nAvailability: | `:on_request`\nFlow control: | `:auto`\n\n\n### `:output`\n\nAccepted formats:\n```\n%RemoteStream{type: :bytestream, content_format: MP4}\n```\n\nDirection: | `:output`\nAvailability: | `:always`\nFlow control: | `:auto`","ref":"Membrane.MP4.Muxer.ISOM.html#module-pads"},{"type":"function","title":"Membrane.MP4.Muxer.ISOM.options/0","doc":"Returns description of options available for this module","ref":"Membrane.MP4.Muxer.ISOM.html#options/0"},{"type":"type","title":"Membrane.MP4.Muxer.ISOM.t/0","doc":"Struct containing options for `Membrane.MP4.Muxer.ISOM`","ref":"Membrane.MP4.Muxer.ISOM.html#t:t/0"},{"type":"module","title":"Membrane.MP4.Demuxer.ISOM","doc":"A Membrane Element for demuxing an MP4.\n\nThe MP4 must have `fast start` enabled, i.e. the `moov` box must precede the `mdat` box.\nOnce the Demuxer identifies the tracks in the MP4, `t:new_tracks_t/0` notification is sent for each of the tracks.\n\nAll the tracks in the MP4 must have a corresponding output pad linked (`Pad.ref(:output, track_id)`).","ref":"Membrane.MP4.Demuxer.ISOM.html"},{"type":"module","title":"Element options - Membrane.MP4.Demuxer.ISOM","doc":"Passed via struct `t:Membrane.MP4.Demuxer.ISOM.t/0`\n\n- `optimize_for_non_fast_start?`  \n\n  ```\n  boolean()\n  ```\n  \n  Default value: `false`  \n  When set to `true`, the demuxer is optimized for working with non-fast_start MP4\n  stream (that means - with a stream, in which the :moov box is put after the :mdat box)\n  You might consider setting that option to `true` if the following two conditions are met:\n  - you are processing large non-fast_start MP4 files\n  - the source of the stream is a \"seekable source\" - currently the only possible\n  option is to use a `Membrane.File.Source` with `seekable?: true` option.\n  \n  When set to `false`, no optimization will be performed, so in case of processing the\n  non-fast_start MP4 stream, the whole content of the :mdat box will be stored in\n  memory.\n  \n  Defaults to `false`.","ref":"Membrane.MP4.Demuxer.ISOM.html#module-element-options"},{"type":"module","title":"Pads - Membrane.MP4.Demuxer.ISOM","doc":"### `:input`\n\nAccepted formats:\n```\n%RemoteStream{type: :bytestream, content_format: content_format} when content_format in [nil, MP4]\n```\n\nDirection: | `:input`\nAvailability: | `:always`\nFlow control: | `:auto`\n\n\n### `:output`\n\nAccepted formats:\n```\n%Membrane.AAC{config: {:esds, _esds}}\n```\n```\n%Membrane.H264{stream_structure: {:avc1, _dcr}, alignment: :au}\n```\n```\n%Membrane.H265{stream_structure: {_hevc, _dcr}, alignment: :au}\n```\n```\n%Membrane.Opus{self_delimiting?: false}\n```\n\nDirection: | `:output`\nAvailability: | `:on_request`\nFlow control: | `:auto`","ref":"Membrane.MP4.Demuxer.ISOM.html#module-pads"},{"type":"function","title":"Membrane.MP4.Demuxer.ISOM.options/0","doc":"Returns description of options available for this module","ref":"Membrane.MP4.Demuxer.ISOM.html#options/0"},{"type":"type","title":"Membrane.MP4.Demuxer.ISOM.new_tracks_t/0","doc":"Notification sent when the tracks are identified in the MP4.\n\nUpon receiving the notification, `Pad.ref(:output, track_id)` pads should be linked\nfor all the `track_id` in the list.\nThe `content` field contains the stream format which is contained in the track.","ref":"Membrane.MP4.Demuxer.ISOM.html#t:new_tracks_t/0"},{"type":"type","title":"Membrane.MP4.Demuxer.ISOM.t/0","doc":"Struct containing options for `Membrane.MP4.Demuxer.ISOM`","ref":"Membrane.MP4.Demuxer.ISOM.html#t:t/0"},{"type":"module","title":"Membrane.MP4.FileTypeBox","doc":"A module containing a function for assembling an MPEG-4 file type box.\n\nThe file type box (`ftyp` atom) is a top-level box that contains specifications\nand compatibility information that media players can use to correctly interpret\nan MPEG-4 container.\n\nFor more information about the file type box, refer to\n[ISO/IEC 14496-12](https://www.iso.org/standard/74428.html).","ref":"Membrane.MP4.FileTypeBox.html"},{"type":"function","title":"Membrane.MP4.FileTypeBox.assemble/3","doc":"","ref":"Membrane.MP4.FileTypeBox.html#assemble/3"},{"type":"module","title":"Membrane.MP4.MediaDataBox","doc":"A module containing a function for assembling an MPEG-4 media data box.\n\nThe media data box (`mdat` atom) is a top-level box that contains actual media data\n(e.g. encoded video frames or audio samples). The data is logically divided into so\ncalled \"chunks\" that consist of \"samples\". There are no assumptions made about chunks\narrangement or sizes in the MPEG-4 specification and chunks belonging to different tracks\ncan (and should) be interleaved.\n\nFor more information about media data box, refer to\n[ISO/IEC 14496-12](https://www.iso.org/standard/74428.html).","ref":"Membrane.MP4.MediaDataBox.html"},{"type":"function","title":"Membrane.MP4.MediaDataBox.assemble/1","doc":"","ref":"Membrane.MP4.MediaDataBox.html#assemble/1"},{"type":"module","title":"Membrane.MP4.MovieBox","doc":"A module providing a function assembling an MPEG-4 movie box.\n\nThe movie box (`moov`) is a top-level box that contains information about\na presentation as a whole. It consists of:\n\n  * exactly one movie header (`mvhd` atom)\n\n    The movie header contains media-independent data, such as the\n    number of tracks, volume, duration or timescale (presentation-wide).\n\n  * one or more track box (`trak` atom)\n\n  * zero or one movie extends box (`mvex` atom)\n\nFor more information about movie box and its contents, refer to documentation of\n`Membrane.MP4.MovieBox` submodules or to [ISO/IEC 14496-12](https://www.iso.org/standard/74428.html).","ref":"Membrane.MP4.MovieBox.html"},{"type":"function","title":"Membrane.MP4.MovieBox.assemble/2","doc":"","ref":"Membrane.MP4.MovieBox.html#assemble/2"},{"type":"module","title":"Membrane.MP4.MovieBox.MovieExtendsBox","doc":"The module provides a function that assembles an MPEG-4 movie extends box (`mvex` atom).\n\nThe movie extends box provides information about movie fragment boxes in case when\nmedia data is fragmented (for example in CMAF). It has to contain as many track\nextends box (`trex` atoms) as there are tracks in the movie box.\n\nFor more information about the movie extends box, refer to [ISO/IEC 14496-12](https://www.iso.org/standard/74428.html).","ref":"Membrane.MP4.MovieBox.MovieExtendsBox.html"},{"type":"function","title":"Membrane.MP4.MovieBox.MovieExtendsBox.assemble/1","doc":"","ref":"Membrane.MP4.MovieBox.MovieExtendsBox.html#assemble/1"},{"type":"module","title":"Membrane.MP4.MovieBox.TrackBox","doc":"A module containing a set of utilities for assembling an MPEG-4 track box.\n\nThe track box (`trak` atom) describes a single track of a presentation. This description includes\ninformation like its timescale, duration, volume, media-specific data (media handlers, sample\ndescriptions) as well as a sample table, which allows media players to find and interpret\ntrack's data in the media data box.\n\nFor more information about the track box, refer to [ISO/IEC 14496-12](https://www.iso.org/standard/74428.html).","ref":"Membrane.MP4.MovieBox.TrackBox.html"},{"type":"function","title":"Membrane.MP4.MovieBox.TrackBox.assemble/1","doc":"","ref":"Membrane.MP4.MovieBox.TrackBox.html#assemble/1"},{"type":"function","title":"Membrane.MP4.MovieBox.TrackBox.unpack/1","doc":"","ref":"Membrane.MP4.MovieBox.TrackBox.html#unpack/1"},{"type":"module","title":"Membrane.MP4.MovieFragmentBox","doc":"A module containing a function for assembling an MPEG-4 movie fragment box.\n\nThe movie fragment box (`moof` atom) is a top-level box and consists of:\n\n  * exactly one movie fragment header (`mfhd` atom)\n\n    The movie fragment header contains a sequence number that is\n    increased for every subsequent movie fragment in order in which\n    they occur.\n\n  * zero or more track fragment box (`traf` atom)\n\n    The track fragment box provides information related to a track\n    fragment's presentation time, duration and physical location of\n    its samples in the media data box.\n\nThis box is required by Common Media Application Format.\n\nFor more information about movie fragment box and its contents refer to\n[ISO/IEC 14496-12](https://www.iso.org/standard/74428.html) or to\n[ISO/IEC 23000-19](https://www.iso.org/standard/79106.html).","ref":"Membrane.MP4.MovieFragmentBox.html"},{"type":"function","title":"Membrane.MP4.MovieFragmentBox.assemble/1","doc":"","ref":"Membrane.MP4.MovieFragmentBox.html#assemble/1"},{"type":"module","title":"Membrane.MP4.SegmentIndexBox","doc":"A module containing a function for assembling a CMAF segment index box.\n\nThe segment index box (`sidx` atom) contains information related to presentation\ntime and byte-range locations of other boxes belonging to its segment.\n\nFor more information about segment index box refer to\n[ISO/IEC 23000-19](https://www.iso.org/standard/79106.html).","ref":"Membrane.MP4.SegmentIndexBox.html"},{"type":"function","title":"Membrane.MP4.SegmentIndexBox.assemble/1","doc":"","ref":"Membrane.MP4.SegmentIndexBox.html#assemble/1"},{"type":"module","title":"Membrane.MP4.SegmentTypeBox","doc":"A module containing a function for assembling a CMAF segment type box.\n\nThe segment type box (`styp` atom) is a top-level box that contains specifications\nand compatibility information that media players can use to correctly interpret\na CMAF segment.\n\nFor more information about the segment type box, refer to\n[ISO/IEC 23000-19](https://www.iso.org/standard/79106.html).","ref":"Membrane.MP4.SegmentTypeBox.html"},{"type":"function","title":"Membrane.MP4.SegmentTypeBox.assemble/3","doc":"","ref":"Membrane.MP4.SegmentTypeBox.html#assemble/3"},{"type":"extras","title":"MPEG-4 container plugin for Membrane Framework","doc":"# MPEG-4 container plugin for Membrane Framework\n\n[![Hex.pm](https://img.shields.io/hexpm/v/membrane_mp4_plugin.svg)](https://hex.pm/packages/membrane_mp4_plugin)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/membrane_mp4_plugin/)\n[![CircleCI](https://circleci.com/gh/membraneframework/membrane_mp4_plugin.svg?style=svg)](https://circleci.com/gh/membraneframework/membrane_mp4_plugin)\n\nThis plugin provides utilities for MP4 container parsing and serialization along with elements for muxing the stream to MP4 or [CMAF](https://www.wowza.com/blog/what-is-cmaf).","ref":"readme.html"},{"type":"extras","title":"Installation - MPEG-4 container plugin for Membrane Framework","doc":"The package can be installed by adding `membrane_mp4_plugin` to your list of dependencies in `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    {:membrane_mp4_plugin, \"~> 0.35.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - MPEG-4 container plugin for Membrane Framework","doc":"### `Membrane.MP4.Muxer.ISOM`\nISOM muxer requires a sink that can handle `Membrane.File.SeekSinkEvent`, e.g. `Membrane.File.Sink`.\nFor an example of muxing streams to a regular MP4 file, refer to [`examples/muxer_isom.exs`](examples/muxer_isom.exs).\n\nTo run the example, you can use the following command:\n```bash\nelixir examples/muxer_isom.exs\n```\n\nYou can expect an `example.mp4` file containing muxed audio and video to be saved in your working directory.\n\n### `Membrane.MP4.Muxer.CMAF`\nFor an example of muxing streams into CMAF format, refer to [`examples/muxer_cmaf.exs`](examples/muxer_cmaf.exs). CMAF requires a special sink, regular `Membrane.File.Sink` will not work correctly. Currently, Membrane Framework has only one sink capable of saving a CMAF stream - `Membrane.HTTPAdaptiveStream.Sink`.\n\nTo run the example, use the following command:\n```bash\nelixir examples/muxer_cmaf.exs\n```\n\nYou can expect `hls_output` folder to appear and be filled with CMAF header and segments, as well as an HLS playlist.\nTo play the stream, you need to serve the contents of the output folder with an HTTP Server. If you are looking for\nsomething quick and simple, you can use Python's [`http.server`](https://docs.python.org/3/library/http.server.html):\n```bash\npython3 -m http.server -d hls_output 8000\n```\nand run the following command to play the stream:\n```bash\nffplay http://localhost:8000/index.m3u8\n```","ref":"readme.html#usage"},{"type":"extras","title":"Updating tests - MPEG-4 container plugin for Membrane Framework","doc":"In case `out_*` reference files in `test/fixtures/cmaf` change, `out_playlist.m3u8` and its dependent playlists should be updated and checked if they are still playable.\nThe current files have been checked with ffplay (FFmpeg) and Safari.","ref":"readme.html#updating-tests"},{"type":"extras","title":"Copyright and License - MPEG-4 container plugin for Membrane Framework","doc":"Copyright 2019, [Software Mansion](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane_mp4_plugin)\n\n[![Software Mansion](https://logo.swmansion.com/logo?color=white&variant=desktop&width=200&tag=membrane-github)](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane_mp4_plugin)\n\nLicensed under the [Apache License, Version 2.0](LICENSE)","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2018 Software Mansion\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"content_type":"text/markdown"}